## ros-dashing-cv-bridge 2.1.4

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)
project(cv_bridge)

find_package(ament_cmake_ros REQUIRED)

# Default to C++14
if(NOT CMAKE_CXX_STANDARD)
  set(CMAKE_CXX_STANDARD 14)
endif()

if(CMAKE_COMPILER_IS_GNUCXX OR CMAKE_CXX_COMPILER_ID MATCHES "Clang")
  add_compile_options(-Wall -Wextra)
endif()

if(NOT ANDROID)
  find_package(PythonLibs)
  if(PYTHONLIBS_VERSION_STRING VERSION_LESS 3)
    find_package(Boost REQUIRED python)
  else()
    find_package(Boost QUIET)
    if(Boost_VERSION LESS 106500)
      find_package(Boost REQUIRED python)
    else()
      # This is a bit of a hack to suppress a warning
      #   No header defined for python3; skipping header check
      # Which should only affect Boost versions < 1.67
      # Resolution for newer versions:
      #  https://gitlab.kitware.com/cmake/cmake/issues/16391
      if (Boost_VERSION LESS 106700)
        set(_Boost_PYTHON3_HEADERS "boost/python.hpp")
      endif()
      find_package(Boost COMPONENTS python3 REQUIRED)
    endif()
  endif()
else()
  find_package(Boost REQUIRED)
endif()

find_package(sensor_msgs REQUIRED)
find_package(OpenCV 3 REQUIRED
  COMPONENTS
    opencv_core
    opencv_imgproc
    opencv_imgcodecs
  CONFIG
)

include_directories(include ${Boost_INCLUDE_DIRS})

if(NOT ANDROID)
  add_subdirectory(python)
endif()

add_subdirectory(src)

# cv_bridge_lib_dir is passed as APPEND_LIBRARY_DIRS for each ament_add_gtest call so
# the project library that they link against is on the library path.
# This is especially important on Windows.
# This is overwritten each loop, but which one it points to doesn't really matter.
set(cv_bridge_lib_dir "$<TARGET_FILE_DIR:${PROJECT_NAME}>")

if(BUILD_TESTING)
  add_subdirectory(test)
endif()

ament_export_dependencies(OpenCV)

ament_export_include_directories(include)
ament_export_libraries(${PROJECT_NAME})

# install the include folder
install(
  DIRECTORY include/${PROJECT_NAME}/
  DESTINATION include/${PROJECT_NAME}
)

ament_package(
  CONFIG_EXTRAS "cmake/cv_bridge-extras.cmake.in"
)

=== python/CMakeLists.txt ===
configure_file(__init__.py.plain.in
  ${CMAKE_CURRENT_BINARY_DIR}/boost/__init__.py
  @ONLY
)

ament_python_install_package(${PROJECT_NAME})

# install(FILES ${CMAKE_CURRENT_BINARY_DIR}/boost/__init__.py
#   DESTINATION ${PYTHON_INSTALL_DIR}/${PROJECT_NAME}/boost/
# )

=== src/CMakeLists.txt ===
# add library
add_library(${PROJECT_NAME} cv_bridge.cpp rgb_colors.cpp)
include(GenerateExportHeader)
generate_export_header(${PROJECT_NAME} EXPORT_FILE_NAME ${PROJECT_NAME}/${PROJECT_NAME}_export.h)
target_include_directories(${PROJECT_NAME} PUBLIC "$<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}>")
ament_target_dependencies(${PROJECT_NAME}
  "OpenCV"
  "sensor_msgs"
)
target_link_libraries(${PROJECT_NAME} ${Boost_LIBRARIES} ${OpenCV_LIBRARIES})

install(TARGETS ${PROJECT_NAME} DESTINATION lib)

install(FILES
  ${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}/${PROJECT_NAME}_export.h
  DESTINATION include/${PROJECT_NAME})

if(NOT ANDROID)
# add a Boost Python library
find_package(PythonInterp REQUIRED)
find_package(PythonLibs "${PYTHON_VERSION_MAJOR}.${PYTHON_VERSION_MINOR}")

# Get the numpy include directory from its python module
if(NOT PYTHON_NUMPY_INCLUDE_DIR)
  execute_process(COMMAND ${PYTHON_EXECUTABLE} -c "import numpy; print(numpy.get_include())"
    RESULT_VARIABLE PYTHON_NUMPY_PROCESS
    OUTPUT_VARIABLE PYTHON_NUMPY_INCLUDE_DIR
    OUTPUT_STRIP_TRAILING_WHITESPACE)

  if(PYTHON_NUMPY_PROCESS EQUAL 0)
    file(TO_CMAKE_PATH "${PYTHON_NUMPY_INCLUDE_DIR}" PYTHON_NUMPY_INCLUDE_CMAKE_PATH)
    set(PYTHON_NUMPY_INCLUDE_DIR ${PYTHON_NUMPY_INCLUDE_CMAKE_PATH} CACHE PATH "Numpy include directory")
  else()
    message(SEND_ERROR "Could not determine the NumPy include directory, verify that NumPy was installed correctly.")
  endif()
endif()

include_directories(${PYTHON_INCLUDE_PATH} ${PYTHON_NUMPY_INCLUDE_DIR})

if(PYTHON_VERSION_MAJOR VERSION_EQUAL 3)
  add_definitions(-DPYTHON3)
endif()

if(OpenCV_VERSION_MAJOR VERSION_EQUAL 3)
  add_library(${PROJECT_NAME}_boost module.cpp module_opencv3.cpp)
else()
  add_library(${PROJECT_NAME}_boost module.cpp module_opencv2.cpp)
endif()
target_link_libraries(${PROJECT_NAME}_boost
  ${PYTHON_LIBRARIES}
  ${PROJECT_NAME}
)

set_target_properties(${PROJECT_NAME}_boost PROPERTIES
                      LIBRARY_OUTPUT_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/boost/
                      PREFIX ""
)
if(APPLE)
  set_target_properties(${PROJECT_NAME}_boost PROPERTIES
                        SUFFIX ".so")
endif()

install(TARGETS ${PROJECT_NAME}_boost DESTINATION ${PYTHON_INSTALL_DIR}/${PROJECT_NAME}/boost/)
endif()

=== debian/changelog ===
ros-dashing-cv-bridge (2.1.4-1bionic) bionic; urgency=high



 -- Ethan Gao <ethan.gao@linux.intel.com>  Fri, 17 Jan 2020 06:00:00 -0000

ros-dashing-cv-bridge (2.1.3-1bionic) bionic; urgency=high

  * populate array.array directly instead of converting to and from a string (#305 <https://github.com/ros-perception/vision_opencv/issues/305>)
  * include Boost to fix Windows build (#290 <https://github.com/ros-perception/vision_opencv/issues/290>)
  * Export interfaces for Win32 Shared Lib (#301 <https://github.com/ros-perception/vision_opencv/issues/301>)
  * Contributors: Dirk Thomas, Jonathan Noyola, Sean Yen

 -- Ethan Gao <ethan.gao@linux.intel.com>  Wed, 23 Oct 2019 05:00:00 -0000

ros-dashing-cv-bridge (2.1.2-1bionic) bionic; urgency=high

  * Suppress Boost Python warning. (#279 <https://github.com/ros-perception/vision_opencv/issues/279>)
  * silence unused return value warnings (#276 <https://github.com/ros-perception/vision_opencv/issues/276>)
  * Contributors: Karsten Knese, Michael Carroll

 -- Ethan Gao <ethan.gao@linux.intel.com>  Thu, 30 May 2019 05:00:00 -0000

ros-dashing-cv-bridge (2.1.1-1bionic) bionic; urgency=high

  * Replace ament commands with colcon (#263 <https://github.com/ros-perception/vision_opencv/issues/263>)
    Latest ros2 repo does not include ament_tools. Executing ament command results in error.
  * Contributors: Lalit Begani

 -- Ethan Gao <ethan.gao@linux.intel.com>  Fri, 26 Apr 2019 05:00:00 -0000

ros-dashing-cv-bridge (2.1.0-1bionic) bionic; urgency=high

  * find boost_python on boost 1.58 (<1.65) (#246 <https://github.com/ros-perception/vision_opencv/issues/246>)
  * Contributors: Mikael Arguedas

 -- Ethan Gao <ethan.gao@linux.intel.com>  Mon, 26 Nov 2018 06:00:00 -0000

ros-dashing-cv-bridge (2.0.5-1bionic) bionic; urgency=high

  * remove redundant ament_auto_lint dependency to release package
  * fix test_encode_decode_cv2_compressed runtime error with JPEG2000
  * change python3-numpy as build and execution dependency to fix building
    error while releasing package
  * Contributor: Ethan Gao

 -- Ethan Gao <ethan.gao@linux.intel.com>  Fri, 17 Aug 2018 05:00:00 -0000

ros-dashing-cv-bridge (2.0.4-1bionic) bionic; urgency=high

  * Add libopencv-dev as dependency of cv_bridge
  * Replace assert_equal with assert to remove dependency to nose package
  * Contributor: Ethan Gao

 -- Ethan Gao <ethan.gao@linux.intel.com>  Tue, 14 Aug 2018 05:00:00 -0000

ros-dashing-cv-bridge (2.0.3-1bionic) bionic; urgency=high

  * fix the build warning with colcon building
  * optimize buffer type of imgmsg_to_cv2()
  * add python3_opencv and python3_numpy as dependency
  * uncrustify 0.67 coding style alignment
  * Contributors: Mikael Arguedas, Lars Berscheid, Ethan Gao

 -- Ethan Gao <ethan.gao@linux.intel.com>  Tue, 07 Aug 2018 05:00:00 -0000

ros-dashing-cv-bridge (2.0.2-1bionic) bionic; urgency=high

  * fix rosdep keys issue of opencv3

 -- Ethan Gao <ethan.gao@linux.intel.com>  Fri, 29 Jun 2018 05:00:00 -0000

ros-dashing-cv-bridge (2.0.1-1bionic) bionic; urgency=high



 -- Ethan Gao <ethan.gao@linux.intel.com>  Thu, 28 Jun 2018 05:00:00 -0000

ros-dashing-cv-bridge (2.0.0-1bionic) bionic; urgency=high

  * Port cv_bridge to ros2
  * Remove the old inherent boost files
  * Replace boost code with newer C++ standard higher than C++11
  * Add a new readme
  * Adapt message definition like sensor_msg/Image etc in ROS2
  * Coding style alignment with ROS2 using cppcheck/cpplint and python flake8/pep257
  * Enable all the C++/Python unit test with gtest and unittest with ament tools
  * Contributors: Ethan Gao

 -- Ethan Gao <ethan.gao@linux.intel.com>  Wed, 06 Jun 2018 05:00:00 -0000

ros-dashing-cv-bridge (1.12.7-1bionic) bionic; urgency=high



 -- Ethan Gao <ethan.gao@linux.intel.com>  Sun, 12 Nov 2017 06:00:00 -0000

ros-dashing-cv-bridge (1.12.6-1bionic) bionic; urgency=high

  * fix endianness issues
  * Contributors: Vincent Rabaud

 -- Ethan Gao <ethan.gao@linux.intel.com>  Sat, 11 Nov 2017 06:00:00 -0000

ros-dashing-cv-bridge (1.12.5-1bionic) bionic; urgency=high

  * add version_gte for opencv3
    @vrabaud If you'll update opencv3 version as discussed in https://discourse.ros.org/t/opencv-3-3/2674/4, I think we'd better to add 'version_gte' tag so that apt-get install ros-kinetic-cv-bridge also pulls openv3.3 from repository, to avoid API breaking issue between opencv2 and opencv3.
  * Simplify the dependency components of cv_bridge
    Fixes #183 <https://github.com/ros-perception/vision_opencv/issues/183>
  * Fixes #177 <https://github.com/ros-perception/vision_opencv/issues/177>
    The Python bridge was wrong on OpenCV2 with mono8 (and any Mat
    with only two dimensions btw). Took the official Python bridge
    from OpenCV.
  * Add missing test file
    This fixes #171 <https://github.com/ros-perception/vision_opencv/issues/171>
  * Properly deal with alpha in image compression.
    That fixes #169 <https://github.com/ros-perception/vision_opencv/issues/169>
  * Silence warnings about un-used variables
  * export OpenCV variables
  * Contributors: Kei Okada, Victor Lamoine, Vincent Rabaud

 -- Ethan Gao <ethan.gao@linux.intel.com>  Sun, 05 Nov 2017 05:00:00 -0000

ros-dashing-cv-bridge (1.12.4-1bionic) bionic; urgency=high

  * properly find Boost Python 2 or 3
    This fixes #158 <https://github.com/ros-perception/vision_opencv/issues/158>
  * Contributors: Vincent Rabaud

 -- Ethan Gao <ethan.gao@linux.intel.com>  Sun, 29 Jan 2017 06:00:00 -0000

ros-dashing-cv-bridge (1.12.3-1bionic) bionic; urgency=high

  * Use api in sensor_msgs to get byte_depth and num channels
  * Implement cpp conversion of N channel image
    This is cpp version of https://github.com/ros-perception/vision_opencv/pull/141,
    which is one for python.
  * Fill black color to depth nan region
  * address gcc6 build error in cv_bridge and tune
    With gcc6, compiling fails with stdlib.h: No such file or directory,


=== debian/control ===
Source: ros-dashing-cv-bridge
Section: misc
Priority: optional
Maintainer: Ethan Gao <ethan.gao@linux.intel.com>
Build-Depends: debhelper (>= 9.0.0), libboost-all-dev, libopencv-dev, python3-numpy, python3-opencv, ros-dashing-ament-cmake-gtest, ros-dashing-ament-cmake-pytest, ros-dashing-ament-cmake-ros, ros-dashing-ament-lint-auto, ros-dashing-ament-lint-common, ros-dashing-python-cmake-module, ros-dashing-sensor-msgs, ros-dashing-ros-workspace
Homepage: http://www.ros.org/wiki/cv_bridge
Standards-Version: 3.9.2

Package: ros-dashing-cv-bridge
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libboost-all-dev, libopencv-dev, python3-numpy, ros-dashing-ament-index-python, ros-dashing-sensor-msgs, ros-dashing-ros-workspace
Description: This contains CvBridge, which converts between ROS2 Image messages and OpenCV images.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/dashing/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/dashing/setup.sh" ]; then . "/opt/ros/dashing/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/dashing" \
		-DAMENT_PREFIX_PATH="/opt/ros/dashing"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/dashing/setup.sh" ]; then . "/opt/ros/dashing/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/dashing/setup.sh" ]; then . "/opt/ros/dashing/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/dashing/setup.sh" ]; then . "/opt/ros/dashing/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-dashing-cv-bridge//opt/ros/dashing/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/dashing/setup.sh" ]; then . "/opt/ros/dashing/setup.sh"; fi && \
	dh_auto_install
